		/********** GENERADOR DEL ALGORITMO DE PERES VERSION EXHAUSTIVA PARA DIMENSION N **************/
	#include <stdio.h>
	#include <string.h>
	
	#define MAXCAR 256
	
		/** Alberto Sols Encina. Copyright 2010/2011. Histrico:
			14-10-2010: - Descripcin del prembulo.
			15-10-2010: - programacin del AllInKn. Nota: falta generar indentaciones en el cdigo.
			16-10-2010: - Generacin de comentarios.
			20-10-2010: - Anadida la cadena 's' que se usa para escribir en el fichero.
			28-11-2010: - Cambios en la codificacin de AllInKn.
			13-12-2010: - Modularizacin de los cdigos AllInKn y numberKn, cdigos extrados en ficheros aparte.
			13-12-2010: - Aadidas clusulas DYNALLOC para almacenamiento dinmico de los arrays que almacenan
							los Kn que existen en el grafo.
			13-12-2010: - Definicin de la estructura StructInKn que almacena el nmero de Kn existentes
							en el grafo y los vrtices que los forman. Ahora la funcin numberKn devuelve una estructura.
			27-12-2010: - Utilizacin de funciones de manipulacin del fichero propias de C.
			30-12-2010: - Declaracin de cabecera de funciones auxiliares.
			30-12-2010: - Cdigo compilado correctamente.
			07-01-2011: - Corregidos indices de funciones.
			07-01-2011: - Extrada la definicin de la estructura StructInKn en "AlgPeres.h"
			07-01-2011: - Aadido la generacin del fichero "AlgPeres.h" que se incluye en "AlgPeres.c" 
			25-03-2011: - Instrucciones de liberacin de memoria dinmica.
			07-04-2011: - Modificada la estructura del archivo de cabecera, ya nos son necesarios los campos Tx_sz (No se usa DYNALLOC). 
		**/
		
	/** Este programa escribe el cdigo C del algoritmo de Peres para dimensin N. 
		Main devuelve -1 en caso de error, devuelve 0 en cualquier otro caso. **/
int main (int argc, int argv[]){

			/*****************************Generator File "AlgPeres.c"*******************************/
			//Varbiables del programa
			int contador;
			/** pasamos como argumento la dimensin con la que trabajar (dim)**/
			long dim= (long)atoi(argv[1]);
			char s [MAXCAR];
			FILE *f;
			FILE *fh;
			char variable_indice = 'a'; //usaremos como nombres de los arryas de la estructura usando de la a a la z (siguiendo el cdigo ASCII).
			
			//char valueTx [dim][12];  almacenamos los nombres de los arryas que contendran los vrtices que forman kns
			
			//Apertura de fichero
			if ((f=fopen("AlgPeres.c","w")) == NULL){
				 perror("Error al abrir el archivo f");
				 return -1;}
			
		sprintf(s,"/** Algoritmo de Peres para dimensin %ld (versin exhausiva)**/\n",dim);	
		fputs(s, f); //uso de formato de texto
		sprintf(s,"/** Alberto Solis Encina. Copyright 2011. MA1.**/\n");
		fputs(s, f);
		sprintf(s,"#include <stdio.h>\n#include \"AlgPeres.h\" \n#include \"gtools.h\" \n#include \"gutils.h\" \n#include \"AllInKn.c\" \n#include \"numberKn.c\" \n\n");
		fputs(s, f);
		
		
		//-------------------------------------------------------------------------
		sprintf(s, "int PeresColorN (graph* g, int m, int n){ \n\n", dim);
		fputs(s, f);
		
		//************************** Variables ************************************
		sprintf(s,"int c[n], l[n], oc[n][n];\nSTRUCTKN structkn = NULL; \n");
		fputs(s, f);
		sprintf(s, "int i, lvl, ng, ngs, e, s, nt, nt2, b; \n int last;\n");
		fputs(s,f);
		//*************************************************************************
		
		
		sprintf(s,"\n/** Parece ser que Peres considera que en el grafo de entrada todos los vrtices estn contenidos en un Kn, de no ser as el algoritmo no colorea todo el grafo**/\n\n");
		fputs(s, f);
		sprintf(s, "if (!(allInKn (g,m,n))) return 0;\n else {\n\n");
		fputs(s, f);
		
		sprintf (s,"/**Los arrays Tx son las n-plas con los vrtices que forman los Kn.\n C(J) es el color del vrtice J: 0 = rojo, 1 = verde, %ld+1 = desconocido, que corresponde a la dimensin del problema + 1.\n",dim);
		fputs(s, f);
		sprintf(s, "L(K) es el rayo cuyo color fue asignado en la asignacin k-sima.\n OC(LVL,J) es el color del rayo J despus de LVL asignaciones arbitrarias.\n**/");
		fputs(s, f);
		
		//Inicializacin
		sprintf(s, "\n//Inicializacin\n for(i=0;i<n;i++){\n c[i]=%ld+1; //Inicialmente los colores de los vertices son desconocidos\n}\n",dim);
		fputs(s, f);

		sprintf(s, "\nlvl=-1; //Ninguna asignacin realizada, la cuestin es que los ndices deben empezar por 0\n");
		fputs(s,f);
		
		//Bsqueda del nmero de Kns
		sprintf(s, "structkn = numberKn(g,m,n);\n\n"); //la inicializacin (reserva de memoria, etc.) de dicha estructura se realiza en "numberKn"
		fputs(s, f);
		
		//Bloque principal del cdigo
		sprintf(s, "/* Eleccin arbitraria del siguiente vrtice al que se le asigna color verde, cuyo nmero es NG.\n El resto de los vrtices deben ser coloreados de forma consistente*/\n");
		fputs(s, f);
		
		//main_label
		sprintf(s, "main_label:\n\n for(ng=0;ng<n;ng++){\n if(c[ng] == %ld+1){ \n c[ng] = 1;\n ngs=ng;\n goto color_consisted; //Busca el coloreado resultante despus de la asignacin arbitraria.\n } \n }\n", dim);
		fputs(s, f);
		
		//Liberacin de memoria al final del algoritmo.
		variable_indice='a';
		for(contador=0;contador<dim;contador++){
			sprintf(s,"free(structkn->T%c);\n",variable_indice, variable_indice);
			fputs(s, f);
			variable_indice++;
		
		}
		
		sprintf(s, "free(structkn);\n\nreturn 0;\n\n");
		fputs(s,f);
		
		//color_consisted
		sprintf(s, "color_consisted:\n\n lvl = lvl+1;\n last = 1;\n //La ltima asignacin arbitraria fue un vrtice verde \n l[lvl] = ngs;\n //Esta asignacin arbitraria se hizo para el vrtice NG\n\n");
		fputs(s, f);
		
		sprintf(s, "for(e=0;e<n;e++){\n\n //Guarda la informacin de la situacin despus de LVL elecciones arbitrarias\n oc[lvl][e] = c[e];\n }\n\n");
		fputs(s, f);
		
		//search_coloring
		sprintf(s, "search_coloring:\n\n for(s=0;s<n;s++){\n\n //Todos los vrtices adyacentes a uno verde deben ser rojos.\n if((g[ngs] & bit[s])){\n c[s] = 0;}\n}\n\n");
		fputs(s, f);
		
		//search_in_kn
		sprintf(s, "search_in_kn:\n for(nt=0;nt<structkn->nKn;nt++){\n//Chequea los Kn donde todos los vrtices son rojos.\n\n");
		fputs(s, f);
		
		//sprintf(s, "if(c[%s[nt]]", valueTx[0]);
		sprintf(s, "\tif(c[structkn->Ta[nt]]");
		fputs(s, f);
		
		variable_indice='b';
		for(contador=1;contador<dim;contador++){
			//sprintf(s, "+c[%s[nt]]", valueTx[contador]);
			sprintf(s, "+c[structkn->T%c[nt]]", variable_indice);			
			fputs(s, f);
			variable_indice++;
		}
		
		sprintf(s,"== 0){\n\n\t //Si existe un K%d donde todos los vrtices son rojos y estamos en la raz del backtracking, entonces no es coloreable.\n",dim);
		fputs(s, f);
		
		sprintf(s, "\t\tif(last + lvl < 0){\n");
		fputs(s, f);
		
		//Liberacin de memoria al final del algoritmo.
		variable_indice='a';
		for(contador=0;contador<dim;contador++){
			sprintf(s,"\t\tfree(structkn->T%c);\n",variable_indice, variable_indice);
			fputs(s, f);
			variable_indice++;
		
		}
		
		sprintf(s, "\t\tfree(structkn);\n\n\t\t return 1; //No existe una coloracin consistente\n");
		fputs(s,f);
		
		sprintf(s, "\n}\n");
		fputs(s, f);
		
		sprintf(s, "\t\telse{ //Si no estamos en la raz del backtracking entonces retorcedemos\n\n\t\t\t for(b=0;b<n;b++){\n\t\t\t //Restauramos los valores precedentes al ultimo salto\n ");
		fputs(s, f);
		
		sprintf(s, "\t\t\tc[b] = oc[lvl][b];\n}\n\n\t\t\t c[l[lvl]]=0;\n\t\t\t last=0;\n\t\t\t lvl=lvl-1;\n\t\t\t goto search_in_kn;\n\t\t\t //vuelve al bucle externo.\n\t } \n\t } \n }\n\n");
		fputs(s, f);
		
		sprintf(s, "for(nt2=0;nt2<structkn->nKn;nt2++){\n //Existen Kn con todos menos 1 vrtices de color rojo y el otro sin colorear?.\n//Si es asi, entonces a dicho vrtice le corresponde color verde.\n\n");
		fputs(s, f);
		
		//sprintf(s, "if( c[%s[nt2]]",valueTx[0]);
		sprintf(s, "\tif( c[structkn->Ta[nt2]]");
		fputs(s, f);
		
		variable_indice='b';
		for(contador=1;contador<dim;contador++){
			//sprintf(s, "+c[%s[nt]]", valueTx[contador]);
			sprintf(s, "+c[structkn->T%c[nt2]]", variable_indice);
			fputs(s, f);
			variable_indice++;
		}
		
		sprintf(s, "== %ld +1){\n\n", dim);
		fputs(s, f);
		
		variable_indice='a';
		for(contador=0;contador<dim;contador++){
			//sprintf(s, "if(c[%s[nt2]] == %ld+1{\n c[%s[nt2]]=1;\n goto search_coloring;\n}\n",valueTx[contador], dim, valueTx[contador]);
			sprintf(s, "\t\tif(c[structkn->T%c[nt2]] == %ld+1){\n\t\t c[structkn->T%c[nt2]]=1;\n\t\t ngs=structkn->T%c[nt2]; \n\t\t goto search_coloring;\n\t\t}\n",variable_indice, dim,variable_indice,variable_indice);
			fputs(s, f);
			variable_indice++;
		}
		
		sprintf(s, "\n}\n}\n\n goto main_label; \n\n}\n}//Fin del Main\n");
		fputs(s, f);
		
		fclose(f);
		


		/*****************************Generator File "AlgPeres.h"*******************************/

	variable_indice='a';
	contador=0;
	//Apertura de fichero
			if ((fh=fopen("AlgPeres.h","w")) == NULL){
				 perror("Error al abrir el archivo fh");
				 return -1;}	
	
	sprintf(s,"/**Estructura STRUCTKN usada para el algoritmo de Peres**/\n\n");
	fputs(s, fh);
	
	sprintf(s, "#ifndef _ALGPERES_H\n#define _ALGPERES_H\n\n");
	fputs(s, fh);


	/** ESTRUCTURA.
			Declaracin de la estructura que nos permitir extraer del cdigo principal la funcin numberKn.
		**/
		sprintf(s, "struct StructInKn {\n ");
		fputs(s, fh);
		
		
		for(contador = 0; contador < dim; contador++){
			
			sprintf(s, "int *T%c;\n", variable_indice, variable_indice);
			fputs(s, fh);
			variable_indice++;
			}
			
		sprintf(s, "long nKn;\n};\n\n");
		fputs(s, fh);
		
		sprintf(s, "typedef struct StructInKn *STRUCTKN;\n\n"); //Declaramos un puntero a la estructura puesto que tenemos que 
									//reservar memoria para los elementos que contiene
		fputs(s, fh);

		sprintf(s, "#endif\n");	
		fputs(s, fh);	

	fclose(fh);

	return 0;
}
		
